//Listing 13.17. Wykorzystanie dziedziczenia klas wraz z dynamicznym zarzdzaniem pamici
#include <iostream>
using namespace std;

class Name { // klasa bazowa
  char *name; // dynamiczne zarzdzanie pamici
protected:
  Name(char nm[]); // zapobiega uyciu obiektu
public:
  ~Name(); // zwalnia pami przydzielon dynamicznie
  const char* get() const; } ; // dostp do zawartoci

  Name::Name(char nm[])
  { name = new char[strlen(nm)+1]; // przydziel pami na stercie
  if (name == NULL) { cout << "Brak pamici\n"; exit(1); }
  strcpy(name,nm); } // zainicjalizuj pami na stercie

  const char* Name::get () const
  { return name; } // dostp do danych prywatnych
  Name::~Name()
  { delete [] name; } // zwolnij pami obiektu

  class Address : public Name { // klasa pochodna
  char *email;
  Address(const Address&); // brak semantyki wartoci
  void operator = (const Address&);
public:
  Address(char name[], char address[]); // przydziel pami na stercie
  ~Address();
  void show() const; } ; // wywietla dane obiektu

  Address::Address(char nm[], char addr[]) : Name(nm)
  { email = new char[strlen(addr)+1];
  if (email == NULL) { cout << "Brak pamici\n"; exit(1); }
    strcpy(email,addr); }

  Address::~Address() // zwalnia pami obiektu
  { delete [] email; }
  void Address::show() const // wywietla dane obiektu
  { cout << " Nazwisko: " << Name::get() << endl;
  cout << " Email: " << email << endl << endl; }

int main ()
{
  Address x("Shtern", "shtern@bu.edu"); // kod klienta
  x.show();
  return 0;
}
