//Listing 15.2. Przekazywanie w charakterze argumentw wskanika oraz referencji do klasy bazowej oraz pochodnej.
#include <iostream>
using namespace std;
class Base {                          //klasa bazowa
protected:
   int x;
public:
  Base(int a)                        //do wykorzystania przez klas pochodn
  { x = a; }
  void set (int a)                   //do odziedziczenia
  { x = a; }
  int show() const                   //do odziedziczenia
  { return x; } } ;

class Derived : public Base {       //klasa pochodna
   int y;
public:
  Derived (int a, int b) : Base(a), y(b)
  { }                                 //pusta tre konstruktora
  Derived(const Base &b) : Base(b)    //obsuguje niejawne rzutowania
  { y = 0; }                          //jawna inicjalizacja
  void access (int &a, int &b) const  //dodana do klasy pochodnej
  { a = Base::x;  b = y; } } ;

class Other {                         //kolejna klasa
   int z;
public:
  void setB(const Base &b)           //warto przekazana przez referencj
  { z = b.show(); }
  void setB(const Base *b)           //warto przekazana przez wskanik
  { z = b->show(); }
  void setD(const Derived &d)        //warto przekazana przez referencj
  { int a; d.access(a, z); }
  void setD(const Derived *d)        //warto przekazana przez wskanik
  { int a; d->access(a, z); }
  int get() const                    //funkcja dostpowa
  { return z; }
};

int main()
{
  Base b(30);  Derived d(50,80);                //obiekty powizane
  Other a1, a2;                                 //obiekty niezwiazane
  a1.setB(b);  a2.setD(d);                      //dokadne dopasowanie
  cout << " al=" << a1.get() << "  a2=" << a2.get() << endl;
  a1.setB(d);   a2.setD(b);                     //konwersja niejawna
  cout << " a1=" << a1.get() << "  a2=" << a2.get() << endl;
  a1.setB(&b);  a2.setD(&d);                    //dokadne dopasowanie
  cout << " a1=" << a1.get() << "  a2=" << a2.get() << endl;
  a1.setB(&d);                                  //konwersja niejawna
  // a2.setD(&b);                               //bd skadni
  a2.setD((Derived*)&b);                        //konwersja jawna
  cout << " a1=" << a1.get() << "  a2=" << a2.get() << endl;
  return  0;
}
